﻿package {
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.media.Microphone;
	import flash.system.Security;
	import flash.system.SecurityPanel;

	public class Suiveur extends Sprite {
		private var mover:Sprite;
		private var i:Number=0;
		private var mic:Microphone;



		public function Suiveur() {
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);

			mic=Microphone.getMicrophone();
			Security.showSettings(SecurityPanel.MICROPHONE);
			mic.setLoopBack(true);

			if (mic!=null) {
				mic.setUseEchoSuppression(true);
			}
		}
		private function addedHandler(e:Event):void {
			mover = new Sprite();
			addChild(mover);
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}

		private function enterHandler(e:Event):void {
			mover.x = (stage.stageWidth/2+100);
			mover.y = (stage.stageHeight/2);
			mover.x += mic.activityLevel*5;
			drawElem(i++);
		}

		private function drawElem(nbr:Number):void {
			var elem:Sprite = new Sprite();
			elem.name="ch"+i;
			
			var colors:Array=new Array (0xffffff,0xffff00,0xff0000);
			var choiceColors:Number=0;
			
			if (mic.activityLevel>3 && mic.activityLevel<=7)
			{
				choiceColors=1;
			}
			if (mic.activityLevel>7){
				choiceColors=2;
			}
			
			elem.graphics.lineStyle(1,colors[choiceColors]);
			var a:Number=50;
			elem.graphics.moveTo((Math.random()-.5)*10,-(mic.activityLevel*10+Math.random()*a));
			elem.graphics.lineTo((Math.random()-.5)*10,mic.activityLevel*10+Math.random()*a);
			elem.addEventListener(Event.ENTER_FRAME,fadeOut);
			mover.addChild(elem);
		}
		
		private function fadeOut(e:Event):void {
			e.currentTarget.x-=(10+mic.activityLevel);
			e.currentTarget.y+= (Math.random()-.5)*10;
			e.currentTarget.alpha-=0.001;
			
			if (e.currentTarget.x <= (-stage.stageWidth/4+Math.random()*10))
			{
				e.currentTarget.y-=mic.activityLevel*7+5;
				e.currentTarget.alpha-=0.02;
			}
			if (e.currentTarget.alpha<=0) {
				if (mover.getChildByName(e.currentTarget.name)!=null) {
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,fadeOut);
					mover.removeChild(mover.getChildByName(e.currentTarget.name));
				}
			}
		}
	}
}